Index: java/main/src/main/java/com/framsticks/gui/ObjectPanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/ObjectPanel.java	(revision 101)
@@ -5,8 +5,6 @@
 import com.framsticks.gui.controls.ControlOwner;
 import com.framsticks.gui.controls.ValueControl;
-import com.framsticks.gui.controls.ValueControlListener;
 import com.framsticks.params.Access;
 import com.framsticks.params.Param;
-import com.framsticks.params.ValueParam;
 
 import org.apache.logging.log4j.Logger;
@@ -16,9 +14,11 @@
 
 import java.util.Collection;
-import java.util.IdentityHashMap;
+import java.util.HashMap;
 import java.util.Map;
 import static com.framsticks.util.lang.Containers.filterInstanceof;
 
 import com.framsticks.util.FramsticksException;
+
+import static com.framsticks.core.TreeOperations.*;
 
 @SuppressWarnings("serial")
@@ -27,6 +27,6 @@
 	private static final Logger log = LogManager.getLogger(ObjectPanel.class);
 
-	final protected Map<Param, Control> components = new IdentityHashMap<Param, Control>();
-	final protected Map<ValueParam, ValueControl> valueControls = new IdentityHashMap<ValueParam, ValueControl>();
+	final protected Map<String, Control> controls = new HashMap<String, Control>();
+	final protected Map<String, ValueControl> valueControls = new HashMap<String, ValueControl>();
 
 	protected final JPanel contentPanel;
@@ -38,24 +38,13 @@
 		contentPanel = new JPanel();
 		scrollPane = new JScrollPane(contentPanel);
-		contentPanel.setLayout(new BoxLayout(contentPanel, BoxLayout.PAGE_AXIS));
+
 		setupContentComponent(scrollPane);
 
-		Gui.fillWithControls(this, params, components, Control.class);
+		Gui.fillWithControls(this, contentPanel, params, controls, Control.class);
 		setName(framsClass.getId());
 
-		for (final ValueControl c : filterInstanceof(components.values(), ValueControl.class)) {
-			valueControls.put(c.getParam(), c);
+		for (final ValueControl c : filterInstanceof(controls.values(), ValueControl.class)) {
+			valueControls.put(c.getParam().getId(), c);
 			c.setUserEnabled(true);
-			c.setListener(new ValueControlListener() {
-				@Override
-				public boolean onChange(Object newValue) {
-					if (currentPath == null) {
-						return true;
-					}
-					boolean result = treeAtFrame.changeValue(currentPath.assureResolved().getTopObject(), c, newValue);
-					refreshControlButtons();
-					return result;
-				}
-			});
 		}
 
@@ -68,10 +57,14 @@
 		assert frame.isActive();
 		assert currentPath != null;
-		treeAtFrame.pushLocalChanges(currentPath);
+		treeAtFrame.pushUserChangesToTree(currentPath);
+		refreshControlButtons();
 	}
 
-	protected void refreshControlButtons() {
-		assert frame.isActive();
-		applyButton.setEnabled(treeAtFrame.hasLocalChanges(currentPath.getTopObject()));
+
+	@Override
+	protected void revertChanges() {
+		assert currentPath != null;
+		removeSideNote(currentPath, treeAtFrame.getUserChangesKey());
+		pullValuesFromLocalToUser(bindAccess(currentPath));
 	}
 
@@ -81,23 +74,25 @@
 		log.debug("refreshing components");
 
-		final Map<ValueControl, Object> values = new IdentityHashMap<ValueControl, Object>();
-		for (Map.Entry<ValueParam, ValueControl> e : valueControls.entrySet()) {
-			values.put(e.getValue(), access.get(e.getKey().getId(), Object.class));
+		UserChanges userChanges = getSideNote(currentPath, treeAtFrame.getUserChangesKey());
+
+
+		for (Map.Entry<String, ValueControl> e : valueControls.entrySet()) {
+			String id = e.getKey();
+			Object value;
+			if (userChanges != null && userChanges.changes.containsKey(id)) {
+				value = userChanges.changes.get(id);
+			} else {
+				value = access.get(id, Object.class);
+			}
+
+			e.getValue().pushValueToUserInterface(value);
 		}
 
-
-		NodeAtFrame nodeAtFrame = treeAtFrame.getLocalInfo(currentPath.getTopObject());
-		if (nodeAtFrame != null) {
-			for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
-				values.put(e.getKey(), e.getValue());
-			}
+		for (Map.Entry<String, Control> e : controls.entrySet()) {
+			e.getValue().refreshState();
 		}
 
-		for (Map.Entry<ValueControl, Object> e : values.entrySet()) {
-			e.getKey().pushValueToUserInterface(e.getValue());
-		}
 		refreshControlButtons();
-		ObjectPanel.this.revalidate();
-
+		// ObjectPanel.this.revalidate();
 	}
 
@@ -105,9 +100,4 @@
 	public String getTitle() {
 		return "Properties";
-	}
-
-	@Override
-	public JPanel getPanelForControls() {
-		return contentPanel;
 	}
 
@@ -122,3 +112,13 @@
 	}
 
+	@Override
+	public boolean onValueChange(ValueControl control, Object newValue) {
+		if (currentPath == null) {
+			return true;
+		}
+		boolean result = treeAtFrame.changeValue(currentPath.assureResolved().getTopObject(), control, newValue);
+		refreshControlButtons();
+		return result;
+	}
+
 }
Index: java/main/src/main/java/com/framsticks/gui/StatusBar.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/StatusBar.java	(revision 101)
@@ -15,8 +15,9 @@
 import com.framsticks.util.FramsticksException;
 import com.framsticks.util.dispatching.Dispatcher;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.RunAt;
 
-public class StatusBar implements ExceptionResultHandler, Dispatcher<StatusBar> {
+public class StatusBar implements ExceptionResultHandler {
 	private static final Logger log = LogManager.getLogger(StatusBar.class);
 
@@ -24,14 +25,31 @@
 	protected JPanel swing;
 	protected ExceptionResultHandler exceptionHandler;
+	protected final Dispatcher<?> dispatcher;
 
 	/**
 	 *
 	 */
-	public StatusBar() {
+	public StatusBar(Dispatcher<?> dispatcher) {
+		this.dispatcher = dispatcher;
+	}
+
+	@SuppressWarnings({"rawtypes", "unchecked"})
+	public void showInfo(final Object value) {
+		Dispatching.dispatchIfNotActive(dispatcher, new RunAt(this) {
+
+			@Override
+			protected void runAt() {
+				String text = value.toString();
+				log.info("info: {}", text);
+				statusBar.setText(text);
+
+			}
+		});
 	}
 
 	@Override
+	@SuppressWarnings({"rawtypes", "unchecked"})
 	public void handle(final FramsticksException exception) {
-		dispatch(new RunAt<StatusBar>(this) {
+		dispatcher.dispatch(new RunAt(this) {
 
 			@Override
@@ -58,14 +76,4 @@
 	}
 
-	@Override
-	public boolean isActive() {
-		return SwingDispatcher.getInstance().isActive();
-	}
-
-	@Override
-	public void dispatch(RunAt<? extends StatusBar> runnable) {
-		SwingDispatcher.getInstance().dispatch(runnable);
-	}
-
 	/**
 	 * @return the swing
Index: java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/SwingDispatcher.java	(revision 101)
@@ -1,11 +1,7 @@
 package com.framsticks.gui;
 
-import java.awt.event.ActionEvent;
-import java.awt.event.ActionListener;
 
 import com.framsticks.util.dispatching.AbstractJoinable;
 import com.framsticks.util.dispatching.Dispatcher;
-import com.framsticks.util.dispatching.JoinableDispatcher;
-import com.framsticks.util.dispatching.Task;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
 
@@ -16,5 +12,5 @@
  * @author Piotr Sniegowski
  */
-public class SwingDispatcher<C> extends AbstractJoinable implements JoinableDispatcher<C> {
+public class SwingDispatcher<C> extends AbstractJoinable implements Dispatcher<C> {
 
 	@SuppressWarnings("rawtypes")
@@ -42,20 +38,4 @@
 	@Override
 	public final void dispatch(RunAt<? extends C> runnable) {
-		if (runnable instanceof Task) {
-			final Task<?> task = (Task<?>) runnable;
-			Timer timer = new Timer(0, null);
-			timer.addActionListener(new ActionListener() {
-
-				@Override
-				public void actionPerformed(ActionEvent event) {
-					task.run();
-				}
-
-			});
-			timer.setInitialDelay((int) (task.getMoment() - System.currentTimeMillis()));
-			timer.setRepeats(false);
-			timer.start();
-			return;
-		}
 		SwingUtilities.invokeLater(runnable);
 	}
@@ -73,5 +53,5 @@
 	@Override
 	protected void joinableInterrupt() {
-		finish();
+		finishJoinable();
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/TreeAtFrame.java	(revision 101)
@@ -4,11 +4,13 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.core.SideNoteKey;
 import com.framsticks.core.Tree;
 import com.framsticks.core.Node;
 import com.framsticks.core.Path;
-import com.framsticks.core.TreeOperations;
+import static com.framsticks.core.TreeOperations.*;
 import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.params.CompositeParam;
 import com.framsticks.params.FramsClass;
+import com.framsticks.params.PrimitiveParam;
 
 import java.util.*;
@@ -30,4 +32,6 @@
 	protected Node rootNode;
 
+	protected final SideNoteKey<UserChanges> userChangesKey = SideNoteKey.make(UserChanges.class);
+
 	public TreeAtFrame(Tree tree, Frame frame) {
 		this.frame = frame;
@@ -44,4 +48,11 @@
 	public Tree getTree() {
 		return tree;
+	}
+
+	/**
+	 * @return the userChangesKey
+	 */
+	public SideNoteKey<UserChanges> getUserChangesKey() {
+		return userChangesKey;
 	}
 
@@ -71,5 +82,5 @@
 		if (panels.isEmpty()) {
 			panel = new EmptyTreePanel(parameters);
-		} else 	if (panels.size() == 1) {
+		} else	if (panels.size() == 1) {
 			panel = panels.get(0);
 		} else {
@@ -83,49 +94,29 @@
 	}
 
-
-	public boolean hasLocalChanges(Object object) {
-		NodeAtFrame nodeAtFrame = tree.getSideNote(object, this, NodeAtFrame.class);
-		if (nodeAtFrame == null) {
-			return false;
-		}
-		return !nodeAtFrame.localChanges.isEmpty();
-	}
-
-	public NodeAtFrame assureLocalInfo(Object object) {
-		assert frame.isActive();
-		NodeAtFrame nodeAtFrame = tree.getSideNote(object, this, NodeAtFrame.class);
-
-		if (nodeAtFrame == null) {
-			nodeAtFrame = new NodeAtFrame();
-			// log.debug();
-			tree.putSideNote(object, this, nodeAtFrame);
-		}
-		return nodeAtFrame;
-	}
-
-	public NodeAtFrame getLocalInfo(Object object) {
-		return tree.getSideNote(object, this, NodeAtFrame.class);
-	}
-
 	public boolean changeValue(Object object, ValueControl component, Object newValue) {
 		log.debug("changing value of {} to '{}'", component, newValue);
 
-		assureLocalInfo(object).localChanges.put(component, newValue);
+		getOrCreateSideNote(tree, object, userChangesKey).changes.put(component.getParam().getId(), newValue);
 
 		return true;
 	}
 
-	public void pushLocalChanges(Path path) {
+
+	public void pushUserChangesToTree(final Path path) {
 		assert frame.isActive();
 		path.assureResolved();
 
-		NodeAtFrame nodeAtFrame = getLocalInfo(path.getTopObject());
-		if (nodeAtFrame == null) {
+		final UserChanges userChanges = getSideNote(path, userChangesKey);
+		if (userChanges == null) {
 			return;
 		}
-		for (Map.Entry<ValueControl, Object> e : nodeAtFrame.localChanges.entrySet()) {
-			TreeOperations.set(path, e.getKey().getParam(), e.getValue(), new FutureHandler<Integer>(frame) {
+		removeSideNote(path, userChangesKey);
+
+		for (final Map.Entry<String, Object> e : userChanges.changes.entrySet()) {
+			set(path, getParam(path, e.getKey(), PrimitiveParam.class), e.getValue(), new FutureHandler<Integer>(frame) {
 				@Override
 				protected void result(Integer flag) {
+					assert frame.isActive();
+					userChanges.changes.remove(e.getKey());
 				}
 			});
Index: java/main/src/main/java/com/framsticks/gui/TreePanel.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/TreePanel.java	(revision 101)
@@ -2,5 +2,6 @@
 
 import com.framsticks.core.Path;
-import com.framsticks.core.TreeOperations;
+import com.framsticks.core.Tree;
+import static com.framsticks.core.TreeOperations.*;
 import com.framsticks.gui.tree.AbstractNode;
 import com.framsticks.gui.tree.TreeNode;
@@ -28,5 +29,5 @@
 		}
 		setCurrentPath(path);
-		pullValuesFromLocalToUser(TreeOperations.bindAccess(path));
+		pullValuesFromLocalToUser(bindAccess(path));
 	}
 
@@ -79,5 +80,12 @@
 		return treeAtFrame;
 	}
-
+	public final Object getCurrentObject() {
+		assert currentPath != null;
+		return currentPath.getTopObject();
+	}
+	public final Tree getTree() {
+		assert currentPath != null;
+		return currentPath.getTree();
+	}
 
 	public final String getClassName() {
Index: java/main/src/main/java/com/framsticks/gui/UserChanges.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/UserChanges.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/UserChanges.java	(revision 101)
@@ -0,0 +1,14 @@
+package com.framsticks.gui;
+
+import java.util.IdentityHashMap;
+import java.util.Map;
+
+
+public class UserChanges {
+
+	protected final Map<String, Object> changes = new IdentityHashMap<>();
+
+	public UserChanges() {
+	}
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 101)
@@ -10,4 +10,5 @@
 import org.apache.logging.log4j.LogManager;
 
+import com.framsticks.gui.Gui;
 import com.framsticks.params.types.BooleanParam;
 
@@ -31,5 +32,5 @@
 		});
 		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
-		addAsOnlyChild(checkBox);
+		Gui.addLeftToLabel(this, checkBox);
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 101)
@@ -1,12 +1,14 @@
 package com.framsticks.gui.controls;
 
-import java.awt.BorderLayout;
+// import java.awt.BorderLayout;
 
-import javax.swing.JComponent;
+
 import javax.swing.JPanel;
 
+import com.framsticks.core.Path;
 import com.framsticks.params.ParamFlags;
 import com.framsticks.params.Param;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.Misc;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 
@@ -57,11 +59,7 @@
 
 	public final boolean isReadonly() {
-		return !userEnabled || param.hasFlag(ParamFlags.READONLY);
+		return !userEnabled || param.hasFlag(ParamFlags.READONLY) || param.hasFlag(ParamFlags.USERREADONLY);
 	}
 
-	protected void addAsOnlyChild(JComponent component) {
-		this.setLayout(new BorderLayout());
-		this.add(component, BorderLayout.CENTER);
-	}
 
 	@Override
@@ -74,3 +72,14 @@
 		owner.handle(exception);
 	}
+
+	public Path getCurrentPath() {
+		return owner.getCurrentPath();
+	}
+
+	public Path assureCurrentPath() {
+		return Misc.throwIfNull(owner.getCurrentPath());
+	}
+
+	public void refreshState() {
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 101)
@@ -1,5 +1,4 @@
 package com.framsticks.gui.controls;
 
-import javax.swing.JPanel;
 
 import com.framsticks.core.Path;
@@ -9,7 +8,7 @@
 public interface ControlOwner extends ExceptionResultHandler {
 
-	public JPanel getPanelForControls();
 	public Path getCurrentPath();
 	public Frame getFrame();
+	public boolean onValueChange(ValueControl control, Object newValue);
 
 }
Index: java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 101)
@@ -1,4 +1,5 @@
 package com.framsticks.gui.controls;
 
+import com.framsticks.gui.Gui;
 import com.framsticks.params.types.EnumParam;
 import com.framsticks.util.lang.Numbers;
@@ -35,5 +36,5 @@
 			}
 		});
-		addAsOnlyChild(list);
+		Gui.addLeftToLabel(this, list);
 	}
 
Index: java/main/src/main/java/com/framsticks/gui/controls/EventControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 101)
@@ -1,11 +1,27 @@
 package com.framsticks.gui.controls;
 
-import java.awt.Dimension;
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
-
-import javax.swing.JButton;
-
+import java.text.SimpleDateFormat;
+import java.util.ArrayList;
+import java.util.Date;
+import java.util.List;
+
+
+
+import com.framsticks.core.Path;
+import com.framsticks.core.SideNoteKey;
+import com.framsticks.gui.Frame;
+import com.framsticks.gui.Gui;
+import com.framsticks.gui.table.AbstractTableModel;
+import com.framsticks.params.EventListener;
 import com.framsticks.params.types.EventParam;
+import com.framsticks.util.FramsticksUnsupportedOperationException;
+import com.framsticks.util.dispatching.Dispatching;
+import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.RunAt;
+import com.framsticks.util.lang.Pair;
+
+import static com.framsticks.core.TreeOperations.*;
 
 /**
@@ -13,42 +29,172 @@
  */
 @SuppressWarnings("serial")
-public class EventControl extends Control {
+public class EventControl extends HistoryControl {
 	// private static final Logger log = LogManager.getLogger(EventControl.class.getName());
 
-	protected final JButton button;
-	boolean subscribed = true;
+	@SuppressWarnings("rawtypes")
+	protected final SideNoteKey<EventListener> listenerKey = SideNoteKey.make(EventListener.class);
+
+	public static class History {
+		protected final List<Pair<Date, Object>> entries = new ArrayList<>();
+	};
+
+	protected final SideNoteKey<History> historyKey = SideNoteKey.make(History.class);
+	protected TableModel tableModel;
 
 	public EventControl(final EventParam eventParam) {
 		super(eventParam);
 
-		button = new JButton("subscribe");
-		this.add(button);
-		this.setMaximumSize(new Dimension(Integer.MAX_VALUE, Control.LINE_HEIGHT));
-
-		button.addActionListener(new ActionListener() {
+		mainButton.setText("Subscribe");
+		mainButton.setName("subscription");
+
+		tableModel = new TableModel();
+		resultsTable.setModel(tableModel);
+
+		mainButton.addActionListener(new ActionListener() {
 			@Override
 			public void actionPerformed(ActionEvent e) {
-				if (subscribed) {
-					//panel.getCurrentTreeNode().unsubscribe(eventParam);
-				} else {
-					//panel.getCurrentTreeNode().subscribe(eventParam);
+				final Path path = assureCurrentPath();
+				EventListener<?> listener = getSideNote(path, listenerKey);
+				if (listener != null) {
+					removeSideNote(path, listenerKey);
+					refreshState();
+					path.getTree().removeListener(path, getParam(), listener, FutureHandler.doNothing(Void.class, owner.getFrame()));
+					return;
 				}
+
+				final EventListener<Object> newListener = new EventListener<Object>() {
+					@Override
+					public void action(final Object argument) {
+						/** actions can be invoked from anywhere */
+						Dispatching.dispatchIfNotActive(owner.getFrame(), new RunAt<Frame>(owner.getFrame()) {
+
+							@Override
+							protected void runAt() {
+								getOrCreateSideNote(path.getTree(), path.getTopObject(), historyKey).entries.add(Pair.make(new Date(), argument));
+								refreshTable();
+							}
+						});
+						// owner.getFrame().getStatusBar().showInfo("event " + param + " happened: " + argument);
+					}
+				};
+
+				path.getTree().addListener(path, getParam(), newListener, Object.class, new FutureHandler<Void>(owner.getFrame()) {
+
+					@Override
+					protected void result(Void result) {
+						putSideNote(path, listenerKey, newListener);
+						refreshState();
+					}
+				});
+
 			}
 		});
 
+		updateFoldState();
+		Gui.setupTitledControl(this, controlRow, resultsScrollPane);
 	}
 
 	@Override
 	protected void updateEnabled(boolean enabled) {
-		button.setEnabled(enabled);
-	}
-
-	/*
-	@Override
-	public void refresh() {
-		subscribed = panel.getCurrentTreeNode().hasSubscribed((EventParam)param);
-		button.setText(subscribed ? "unsubscribe" : "subscribe");
-		this.revalidate();
-	}
-	*/
+		mainButton.setEnabled(enabled);
+	}
+
+	public boolean isListening() {
+		return hasSideNote(getCurrentPath(), listenerKey);
+	}
+
+	protected void refreshButtonState() {
+		mainButton.setText(isListening() ? "Don't listen" : "Listen");
+	}
+
+	@Override
+	protected void refreshTable() {
+		History history = getSideNote(assureCurrentPath(), historyKey);
+		tableModel.entries = history != null ? history.entries : null;
+		tableModel.refreshAll();
+	}
+
+	@Override
+	protected void clearTable() {
+		History history = getSideNote(assureCurrentPath(), historyKey);
+		if (history != null) {
+			history.entries.clear();
+		}
+		refreshTable();
+	}
+
+	public void refreshState() {
+		refreshButtonState();
+		refreshTable();
+	}
+
+	@Override
+	public EventParam getParam() {
+		return (EventParam) param;
+	}
+
+
+	public class TableModel extends AbstractTableModel {
+
+		List<Pair<Date, Object>> entries;
+		SimpleDateFormat format = new SimpleDateFormat("HH:mm:ss:SSS");
+
+		@Override
+		public Class<?> getColumnClass(int columnIndex) {
+			return String.class;
+		}
+
+		@Override
+		public int getColumnCount() {
+			return 2;
+		}
+
+		@Override
+		public String getColumnName(int columnIndex) {
+			return columnIndex == 0 ? "Occured at" : "Argument";
+		}
+
+		@Override
+		public int getRowCount() {
+			if (entries == null) {
+				return 0;
+			}
+			if (isFolded()) {
+				return entries.isEmpty() ? 0 : 1;
+			}
+			return entries.size();
+		}
+
+		@Override
+		public Object getValueAt(int rowIndex, int columnIndex) {
+			if (entries == null) {
+				return null;
+			}
+			Pair<Date, Object> entry;
+			if (isFolded()) {
+				if (rowIndex > 0) {
+					return null;
+				}
+				if (entries.isEmpty()) {
+					return null;
+				}
+				entry = entries.get(entries.size() - 1);
+			} else {
+				entry = entries.get(rowIndex);
+			}
+			return columnIndex == 0 ? format.format(entry.first) : entry.second;
+		}
+
+		@Override
+		public boolean isCellEditable(int rowIndex, int columnIndex) {
+			return false;
+		}
+
+		@Override
+		public void setValueAt(Object value, int rowIndex, int columnIndex) {
+			throw new FramsticksUnsupportedOperationException().msg("setting value in event history");
+		}
+
+
+	}
 }
Index: java/main/src/main/java/com/framsticks/gui/controls/HistoryControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/HistoryControl.java	(revision 101)
+++ java/main/src/main/java/com/framsticks/gui/controls/HistoryControl.java	(revision 101)
@@ -0,0 +1,99 @@
+package com.framsticks.gui.controls;
+
+import java.awt.Dimension;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import javax.swing.JButton;
+import javax.swing.JCheckBox;
+import javax.swing.JPanel;
+import javax.swing.JScrollPane;
+import javax.swing.JTable;
+
+import com.framsticks.gui.Gui;
+import com.framsticks.params.Param;
+import com.framsticks.util.swing.TooltipConstructor;
+
+@SuppressWarnings("serial")
+public abstract class HistoryControl extends Control {
+
+	protected final JPanel controlRow;
+	protected final JButton mainButton;
+	protected final JCheckBox foldingCheckbox;
+	protected final JButton clearButton;
+
+	protected final JScrollPane resultsScrollPane;
+	protected final JTable resultsTable;
+
+	public HistoryControl(Param param) {
+		super(param);
+
+		this.setToolTipText(new TooltipConstructor()
+			.append("name", param.getName())
+			.append("id", param.getId())
+			.append("help", param.getHelp())
+			.build());
+
+		controlRow = new JPanel();
+		controlRow.setName("control_row");
+
+		mainButton = new JButton();
+
+		mainButton.setMaximumSize(new Dimension(Integer.MAX_VALUE, LINE_HEIGHT));
+
+		clearButton = new JButton("Clear");
+		clearButton.setName("clear");
+
+		foldingCheckbox = new JCheckBox("Fold");
+		foldingCheckbox.setName("folding");
+		foldingCheckbox.setSelected(true);
+
+		foldingCheckbox.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent e) {
+				updateFoldState();
+			}
+		});
+
+
+		clearButton.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent e) {
+				clearTable();
+			}
+		});
+
+
+
+		Gui.layoutInRow(controlRow, mainButton, foldingCheckbox, clearButton);
+
+		resultsTable = new JTable();
+		resultsScrollPane = new JScrollPane(resultsTable);
+		resultsTable.setShowGrid(false);
+
+
+	}
+
+	public boolean isFolded() {
+		return foldingCheckbox.isSelected();
+	}
+
+	protected void updateFoldState() {
+		int lines = isFolded() ? 1 : 5;
+		int height = lines * LINE_HEIGHT;
+		// resultsTable.getTableHeader().setVisible(!isFolded());
+		resultsScrollPane.setColumnHeaderView(!isFolded() ? resultsTable.getTableHeader() : null);
+		resultsScrollPane.setMaximumSize(new Dimension(Integer.MAX_VALUE, height));
+		resultsScrollPane.setPreferredSize(new Dimension(0, height));
+		if (owner != null) {
+			refreshTable();
+		}
+		this.revalidate();
+		// foldingButton.setText(isFolded ? "Unfold" : "Fold");
+	}
+
+	protected abstract void refreshTable();
+
+	protected abstract void clearTable();
+
+}
Index: java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 100)
+++ java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 101)
@@ -5,13 +5,10 @@
 import com.framsticks.gui.Gui;
 import com.framsticks.params.Param;
-import com.framsticks.params.ValueParam;
 import com.framsticks.params.types.ProcedureParam;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 import com.framsticks.util.dispatching.FutureHandler;
 import com.framsticks.util.dispatching.ThrowExceptionHandler;
-import com.framsticks.util.swing.TooltipConstructor;
 
 import javax.swing.*;
-import javax.swing.border.BevelBorder;
 
 import org.apache.logging.log4j.Logger;
@@ -20,5 +17,5 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
-import java.util.IdentityHashMap;
+import java.util.HashMap;
 import java.util.LinkedList;
 import java.util.List;
@@ -26,36 +23,30 @@
 
 @SuppressWarnings("serial")
-public class ProcedureControl extends Control implements ControlOwner {
+public class ProcedureControl extends HistoryControl implements ControlOwner {
 
 	private static final Logger log = LogManager.getLogger(ProcedureControl.class);
 
-	protected final JButton procedureButton;
+	protected final JPanel argumentsPanel;
 
-	final protected Map<ValueParam, ValueControl> components = new IdentityHashMap<>();
+	final protected Map<String, ValueControl> components = new HashMap<>();
 
 	public ProcedureControl(ProcedureParam procedureParam) {
 		super(procedureParam);
 
-		this.setToolTipText(new TooltipConstructor()
-			.append("name", procedureParam.getName())
-			.append("id", procedureParam.getId())
-			.append("help", procedureParam.getHelp())
-			.build());
 
-		procedureButton = new JButton("Call");
-		procedureButton.setName("call");
+		mainButton.setText("Call");
+		mainButton.setName("call");
 
-		this.setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));
 
-		Gui.fillWithControls(this, procedureParam.getArgumentsType(), components, ValueControl.class);
+		argumentsPanel = new JPanel();
+		argumentsPanel.setName("arguments");
+
+		Gui.fillWithControls(this, argumentsPanel, procedureParam.getArgumentsType(), components, ValueControl.class);
 
 		if (components.size() != procedureParam.getArgumentsType().size()) {
-			procedureButton.setEnabled(false);
-		}
-		if (!components.isEmpty()) {
-			this.setBorder(new BevelBorder(BevelBorder.RAISED));
+			mainButton.setEnabled(false);
 		}
 
-		procedureButton.addActionListener(new ActionListener() {
+		mainButton.addActionListener(new ActionListener() {
 			@Override
 			public void actionPerformed(ActionEvent e) {
@@ -65,5 +56,5 @@
 				final List<Object> arguments = new LinkedList<Object>();
 				for (Param arg : getParam().getArgumentsType()) {
-					Object value = components.get(arg).getCurrentValue();
+					Object value = components.get(arg.getId()).getCurrentValue();
 					arguments.add(value);
 					log.debug("argument {}: {}", arg, value);
@@ -74,7 +65,10 @@
 			}
 		});
-		this.add(procedureButton);
+
+		updateFoldState();
+		Gui.setupTitledControl(this, argumentsPanel, controlRow, resultsScrollPane);
 
 	}
+
 
 	public static void callProcedure(final Path path, final ProcedureParam param, Object[] arguments) {
@@ -93,9 +87,4 @@
 
 	@Override
-	public JPanel getPanelForControls() {
-		return this;
-	}
-
-	@Override
 	public ProcedureParam getParam() {
 		return (ProcedureParam) param;
@@ -104,5 +93,5 @@
 	@Override
 	protected void updateEnabled(boolean enabled) {
-		procedureButton.setEnabled(enabled);
+		mainButton.setEnabled(enabled);
 		for (ValueControl vc : components.values()) {
 			vc.setUserEnabled(enabled);
@@ -120,3 +109,20 @@
 	}
 
+	@Override
+	public boolean onValueChange(ValueControl control, Object newValue) {
+		return true;
+	}
+
+	@Override
+	protected void refreshTable() {
+		// TODO Auto-generated method stub
+
+	}
+
+	@Override
+	protected void clearTable() {
+		// TODO Auto-generated method stub
+
+	}
+
 }
